org.apache.ignite.springdata20.repository.config

## Annotation Type EnableIgniteRepositories

-     @Target(value=TYPE)
       @Retention(value=RUNTIME)
       @Documented
       @Inherited
       @Import(value=IgniteRepositoriesRegistar.class)
      public @interface EnableIgniteRepositories

  Annotation to activate Apache Ignite repositories. If no base package is configured through either `value()`, `basePackages()` or `basePackageClasses()` it will trigger scanning of the package of annotated class.

- - ### Optional Element Summary

    Optional Elements
    Modifier and Type | Optional Element and Description
    --- | ---
    `Class<?>[]` | `basePackageClasses` Type-safe alternative to `basePackages()` for specifying the packages to scan for annotated components.
    `String[]` | `basePackages` Base packages to scan for annotated components.
    `boolean` | `considerNestedRepositories` Configures whether nested repository-interfaces (e.g. defined as inner classes) should be discovered by the repositories infrastructure.
    `org.springframework.context.annotation.ComponentScan.Filter[]` | `excludeFilters` Specifies which types are not eligible for component scanning.
    `org.springframework.context.annotation.ComponentScan.Filter[]` | `includeFilters` Specifies which types are eligible for component scanning.
    `String` | `namedQueriesLocation` Configures the location of where to find the Spring Data named queries properties file.
    `org.springframework.data.repository.query.QueryLookupStrategy.Key` | `queryLookupStrategy` Returns the key of the `QueryLookupStrategy` to be used for lookup queries for query methods.
    `Class<?>` | `repositoryBaseClass` Configure the repository base class to be used to create repository proxies for this particular configuration.
    `Class<?>` | `repositoryFactoryBeanClass` Returns the `FactoryBean` class to be used for each repository instance.
    `String` | `repositoryImplementationPostfix` Returns the postfix to be used when looking up custom repository implementations.
    `String[]` | `value` Alias for the `basePackages()` attribute.

- - ### Element Detail

    - #### value

          public abstract String[] value

      Alias for the `basePackages()` attribute. Allows for more concise annotation declarations e.g.: `@EnableIgniteRepositories("org.my.pkg")` instead of `@EnableIgniteRepositories(basePackages="org.my.pkg")`.
      Default:
        {}

  - - #### basePackages

          public abstract String[] basePackages

      Base packages to scan for annotated components. `value()` is an alias for (and mutually exclusive with) this attribute. Use `basePackageClasses()` for a type-safe alternative to String-based package names.
      Default:
        {}

  - - #### basePackageClasses

          public abstract Class<?>[] basePackageClasses

      Type-safe alternative to `basePackages()` for specifying the packages to scan for annotated components. The package of each class specified will be scanned. Consider creating a special no-op marker class or interface in each package that serves no purpose other than being referenced by this attribute.
      Default:
        {}

  - - #### excludeFilters

          public abstract org.springframework.context.annotation.ComponentScan.Filter[] excludeFilters

      Specifies which types are not eligible for component scanning.
      Default:
        {}

  - - #### includeFilters

          public abstract org.springframework.context.annotation.ComponentScan.Filter[] includeFilters

      Specifies which types are eligible for component scanning. Further narrows the set of candidate components from everything in `basePackages()` to everything in the base packages that matches the given filter or filters.
      Default:
        {}

  - - #### repositoryImplementationPostfix

          public abstract String repositoryImplementationPostfix

      Returns the postfix to be used when looking up custom repository implementations. Defaults to Impl. So for a repository named `PersonRepository` the corresponding implementation class will be looked up scanning for `PersonRepositoryImpl`.
      Returns:
        Postfix to be used when looking up custom repository implementations.
      Default:
        "Impl"

  - - #### namedQueriesLocation

          public abstract String namedQueriesLocation

      Configures the location of where to find the Spring Data named queries properties file.
      Returns:
        Location of where to find the Spring Data named queries properties file.
      Default:
        ""

  - - #### queryLookupStrategy

          public abstract org.springframework.data.repository.query.QueryLookupStrategy.Key queryLookupStrategy

      Returns the key of the `QueryLookupStrategy` to be used for lookup queries for query methods. Defaults to `QueryLookupStrategy.Key.CREATE_IF_NOT_FOUND`.
      Returns:
        Key of the `QueryLookupStrategy` to be used for lookup queries for query methods.
      Default:
        org.springframework.data.repository.query.QueryLookupStrategy.Key.CREATE_IF_NOT_FOUND

  - - #### repositoryFactoryBeanClass

          public abstract Class<?> repositoryFactoryBeanClass

      Returns the `FactoryBean` class to be used for each repository instance. Defaults to `IgniteRepositoryFactoryBean`.
      Returns:
        `FactoryBean` class to be used for each repository instance.
      Default:
        org.apache.ignite.springdata20.repository.support.IgniteRepositoryFactoryBean.class

  - - #### repositoryBaseClass

          public abstract Class<?> repositoryBaseClass

      Configure the repository base class to be used to create repository proxies for this particular configuration.
      Returns:
        Repository base class to be used to create repository proxies for this particular configuration.
      Default:
        org.apache.ignite.springdata20.repository.support.IgniteRepositoryImpl.class

  - - #### considerNestedRepositories

          public abstract boolean considerNestedRepositories

      Configures whether nested repository-interfaces (e.g. defined as inner classes) should be discovered by the repositories infrastructure.
      Default:
        false

2020 Copyright © Apache Software Foundation
| Follow @ApacheIgnite
Ignite Database and Caching Platform | : ver. 2.9.0
Release Date | : October 15 2020